From b6ad6b52ffc5a1e20f86e80e87ae92a2a386af15 Mon Sep 17 00:00:00 2001
From: Mark Reynolds <mreynolds@redhat.com>
Date: Mon, 14 Jul 2014 17:13:07 -0400
Subject: [PATCH] Ticket 47855 - Fix previous commit

Description:  Incorrectly used "standalone" when claering the tmp directory.
              Not all the tickets use the standalone name for the instance object.

https://fedorahosted.org/389/ticket/47855

Jenkins: passed

Reviewed by: ?
---
 dirsrvtests/tickets/ticket47490_test.py            | 2 +-
 dirsrvtests/tickets/ticket47553_single_aci_test.py | 2 +-
 dirsrvtests/tickets/ticket47573_test.py            | 2 +-
 dirsrvtests/tickets/ticket47619_test.py            | 2 +-
 dirsrvtests/tickets/ticket47653MMR_test.py         | 2 +-
 dirsrvtests/tickets/ticket47676_test.py            | 2 +-
 dirsrvtests/tickets/ticket47721_test.py            | 2 +-
 dirsrvtests/tickets/ticket47787_test.py            | 2 +-
 8 files changed, 8 insertions(+), 8 deletions(-)

diff --git a/dirsrvtests/tickets/ticket47490_test.py b/dirsrvtests/tickets/ticket47490_test.py
index 51511b9..1f37d6c 100644
--- a/dirsrvtests/tickets/ticket47490_test.py
+++ b/dirsrvtests/tickets/ticket47490_test.py
@@ -274,7 +274,7 @@ def topology(request):
         consumer.start(timeout=10)
 
     # clear the tmp directory
-    standalone.clearTmpDir(__file__)
+    master.clearTmpDir(__file__)
 
     # 
     # Here we have two instances master and consumer
diff --git a/dirsrvtests/tickets/ticket47553_single_aci_test.py b/dirsrvtests/tickets/ticket47553_single_aci_test.py
index 5911044..4be2470 100644
--- a/dirsrvtests/tickets/ticket47553_single_aci_test.py
+++ b/dirsrvtests/tickets/ticket47553_single_aci_test.py
@@ -236,7 +236,7 @@ def topology(request):
         master2.start(timeout=10)
 
     # clear the tmp directory
-    standalone.clearTmpDir(__file__)
+    master1.clearTmpDir(__file__)
     
     # 
     # Here we have two instances master and consumer
diff --git a/dirsrvtests/tickets/ticket47573_test.py b/dirsrvtests/tickets/ticket47573_test.py
index 8922426..356873d 100644
--- a/dirsrvtests/tickets/ticket47573_test.py
+++ b/dirsrvtests/tickets/ticket47573_test.py
@@ -275,7 +275,7 @@ def topology(request):
         consumer.start(timeout=10)
 
     # clear the tmp directory
-    standalone.clearTmpDir(__file__)
+    master.clearTmpDir(__file__)
 
     # 
     # Here we have two instances master and consumer
diff --git a/dirsrvtests/tickets/ticket47619_test.py b/dirsrvtests/tickets/ticket47619_test.py
index 945f68a..af391ce 100644
--- a/dirsrvtests/tickets/ticket47619_test.py
+++ b/dirsrvtests/tickets/ticket47619_test.py
@@ -205,7 +205,7 @@ def topology(request):
         consumer.start(timeout=10)
 
     # clear the tmp directory
-    standalone.clearTmpDir(__file__)
+    master.clearTmpDir(__file__)
 
     # 
     # Here we have two instances master and consumer
diff --git a/dirsrvtests/tickets/ticket47653MMR_test.py b/dirsrvtests/tickets/ticket47653MMR_test.py
index 5a3f095..bce69c8 100644
--- a/dirsrvtests/tickets/ticket47653MMR_test.py
+++ b/dirsrvtests/tickets/ticket47653MMR_test.py
@@ -239,7 +239,7 @@ def topology(request):
         master2.start(timeout=10)
 
     # clear the tmp directory
-    standalone.clearTmpDir(__file__)
+    master1.clearTmpDir(__file__)
 
     # 
     # Here we have two instances master and consumer
diff --git a/dirsrvtests/tickets/ticket47676_test.py b/dirsrvtests/tickets/ticket47676_test.py
index be7e626..b462fc2 100644
--- a/dirsrvtests/tickets/ticket47676_test.py
+++ b/dirsrvtests/tickets/ticket47676_test.py
@@ -251,7 +251,7 @@ def topology(request):
         master2.start(timeout=10)
 
     # clear the tmp directory
-    standalone.clearTmpDir(__file__)
+    master1.clearTmpDir(__file__)
 
     # 
     # Here we have two instances master and consumer
diff --git a/dirsrvtests/tickets/ticket47721_test.py b/dirsrvtests/tickets/ticket47721_test.py
index 955d4bc..e27a5a8 100644
--- a/dirsrvtests/tickets/ticket47721_test.py
+++ b/dirsrvtests/tickets/ticket47721_test.py
@@ -257,7 +257,7 @@ def topology(request):
         master2.start(timeout=10)
 
     # clear the tmp directory
-    standalone.clearTmpDir(__file__)
+    master1.clearTmpDir(__file__)
 
     # 
     # Here we have two instances master and consumer
diff --git a/dirsrvtests/tickets/ticket47787_test.py b/dirsrvtests/tickets/ticket47787_test.py
index ecb008c..81d5324 100644
--- a/dirsrvtests/tickets/ticket47787_test.py
+++ b/dirsrvtests/tickets/ticket47787_test.py
@@ -239,7 +239,7 @@ def topology(request):
         master2.start(timeout=10)
 
     # clear the tmp directory
-    standalone.clearTmpDir(__file__)
+    master1.clearTmpDir(__file__)
 
     # 
     # Here we have two instances master and consumer
-- 
1.9.3